Index: /trunk/source/Lib/TLibCommon/TComPicYuv.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPicYuv.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPicYuv.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPicYuv.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPicYuvMD5.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComPrediction.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPrediction.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -630,5 +630,9 @@
 
 #if H_3D_DBBP
+#if HS_DBBP_CLEAN_K0048
+PartSize TComPrediction::getPartitionSizeFromDepth(Pel* pDepthPels, UInt uiDepthStride, UInt uiSize, TComDataCU*& pcCU)
+#else
 PartSize TComPrediction::getPartitionSizeFromDepth(Pel* pDepthPels, UInt uiDepthStride, UInt uiSize)
+#endif
 {
   // find virtual partitioning for this CU based on depth block
@@ -639,4 +643,37 @@
   Int iSumDepth = 0;
   Int iSubSample = 4;
+#if HS_DBBP_CLEAN_K0048
+  Int iPictureWidth = pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getPicYuvRec()->getWidth();
+  Int iPictureHeight = pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getPicYuvRec()->getHeight();
+  TComMv cDv = pcCU->getSlice()->getDepthRefinementFlag(  ) ? pcCU->getDvInfo(0).m_acDoNBDV : pcCU->getDvInfo(0).m_acNBDV;
+  if( pcCU->getSlice()->getDepthRefinementFlag(  ) )
+  {
+    cDv.setVer(0);
+  }
+  Int iBlkX = ( pcCU->getAddr() % pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getFrameWidthInCU() ) * g_uiMaxCUWidth  + g_auiRasterToPelX[ g_auiZscanToRaster[ pcCU->getZorderIdxInCU() ] ]+ ((cDv.getHor()+2)>>2);
+  Int iBlkY = ( pcCU->getAddr() / pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getFrameWidthInCU() ) * g_uiMaxCUHeight + g_auiRasterToPelY[ g_auiZscanToRaster[ pcCU->getZorderIdxInCU() ] ]+ ((cDv.getVer()+2)>>2);
+  UInt t=0;
+
+  for (Int y=0; y<uiSize; y+=iSubSample)
+   {
+    for (Int x=0; x<uiSize; x+=iSubSample)
+   {
+if (iBlkX+x>iPictureWidth)
+{
+    Int depthPel = pDepthPels[t];
+    iSumDepth += depthPel;
+} 
+else
+{
+    Int depthPel = pDepthPels[x];
+    t=x;
+    iSumDepth += depthPel;
+}
+   }
+    
+    // next row
+    if (!(iBlkY+y+4>iPictureHeight))
+    pDepthPels += uiDepthStride*iSubSample;
+#else
   for (Int y=0; y<uiSize; y+=iSubSample)
   {
@@ -650,4 +687,5 @@
     // next row
     pDepthPels += uiDepthStride*iSubSample;
+#endif
   }
   
@@ -667,5 +705,18 @@
     for (Int x=0; x<uiSize; x+=iSubSample)
     {
+#if HS_DBBP_CLEAN_K0048
+      Int depthPel = 0;
+if (iBlkX+x>iPictureWidth)
+{
+    depthPel = pDepthPels[t];
+}
+else
+{ 
+    depthPel = pDepthPels[x];
+     t=x;
+}
+#else
       Int depthPel = pDepthPels[x];
+#endif
       
       // decide which segment this pixel belongs to
@@ -696,4 +747,7 @@
     
     // next row
+#if HS_DBBP_CLEAN_K0048
+    if (!(iBlkY+y+4>iPictureHeight))
+#endif
     pDepthPels += uiDepthStride*iSubSample;
   }
@@ -719,14 +773,80 @@
 }
 
+#if HS_DBBP_CLEAN_K0048
+Bool TComPrediction::getSegmentMaskFromDepth( Pel* pDepthPels, UInt uiDepthStride, UInt uiWidth, UInt uiHeight, Bool* pMask, TComDataCU*& pcCU)
+#else
 Bool TComPrediction::getSegmentMaskFromDepth( Pel* pDepthPels, UInt uiDepthStride, UInt uiWidth, UInt uiHeight, Bool* pMask )
+#endif
 {
   // segmentation of texture block --> mask IDs
   Pel*  pDepthBlockStart      = pDepthPels;
-  
+
   // first compute average of depth block for thresholding
   Int iSumDepth = 0;
   Int uiMinDepth = MAX_INT;
   Int uiMaxDepth = 0;
-
+#if HS_DBBP_CLEAN_K0048
+  uiMinDepth = pDepthPels[ 0 ];
+  uiMaxDepth = pDepthPels[ 0 ];
+  iSumDepth  = pDepthPels[ 0 ];
+  UInt t=0;
+  Int iPictureWidth = pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getPicYuvRec()->getWidth();
+  Int iPictureHeight = pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getPicYuvRec()->getHeight();  
+  TComMv cDv = pcCU->getSlice()->getDepthRefinementFlag(  ) ? pcCU->getDvInfo(0).m_acDoNBDV : pcCU->getDvInfo(0).m_acNBDV;
+  if( pcCU->getSlice()->getDepthRefinementFlag(  ) )
+  {
+    cDv.setVer(0);
+  }
+  Int iBlkX = ( pcCU->getAddr() % pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getFrameWidthInCU() ) * g_uiMaxCUWidth  + g_auiRasterToPelX[ g_auiZscanToRaster[ pcCU->getZorderIdxInCU() ] ]+ ((cDv.getHor()+2)>>2);
+  Int iBlkY = ( pcCU->getAddr() / pcCU->getSlice()->getIvPic (true, pcCU->getDvInfo(0).m_aVIdxCan)->getFrameWidthInCU() ) * g_uiMaxCUHeight + g_auiRasterToPelY[ g_auiZscanToRaster[ pcCU->getZorderIdxInCU() ] ]+ ((cDv.getVer()+2)>>2);
+  if (iBlkX>(Int)(iPictureWidth - uiWidth))
+  {
+    iSumDepth += pDepthPels[ iPictureWidth - iBlkX - 1 ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ iPictureWidth - iBlkX - 1 ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ iPictureWidth - iBlkX - 1 ]);
+  }
+  else
+  {
+    iSumDepth += pDepthPels[ uiWidth - 1 ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiWidth - 1 ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiWidth - 1 ]);
+  }
+  if (iBlkY>(Int)(iPictureHeight - uiHeight))
+  {
+    iSumDepth += pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) ]);
+  }
+  else
+  {
+    iSumDepth += pDepthPels[ uiDepthStride * (uiHeight - 1) ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) ]);
+  }
+  if (iBlkY>(Int)(iPictureHeight - uiHeight) && iBlkX>(Int)(iPictureWidth - uiWidth))
+  {
+    iSumDepth += pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) + iPictureWidth - iBlkX - 1 ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) + iPictureWidth - iBlkX - 1 ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) + iPictureWidth - iBlkX - 1 ]);
+  }
+  else if (iBlkY>(Int)(iPictureHeight - uiHeight))
+  {
+    iSumDepth += pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) + uiWidth - 1 ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) + uiWidth - 1 ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (iPictureHeight - iBlkY - 1) + uiWidth - 1 ]);
+  }
+  else if (iBlkX>(Int)(iPictureWidth - uiWidth))
+  {
+    iSumDepth += pDepthPels[ uiDepthStride * (uiHeight - 1) + iPictureWidth - iBlkX - 1 ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) + iPictureWidth - iBlkX - 1 ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) + iPictureWidth - iBlkX - 1 ]);
+  }
+  else
+  {
+    iSumDepth += pDepthPels[ uiDepthStride * (uiHeight - 1) + uiWidth - 1 ];
+    uiMinDepth = std::min( uiMinDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) + uiWidth - 1 ]);
+    uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) + uiWidth - 1 ]);
+  }
+#else
   iSumDepth  = pDepthPels[ 0 ];
   iSumDepth += pDepthPels[ uiWidth - 1 ];
@@ -743,6 +863,6 @@
   uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) ]);
   uiMaxDepth = std::max( uiMaxDepth, (Int)pDepthPels[ uiDepthStride * (uiHeight - 1) + uiWidth - 1 ]);
-
-  
+#endif
+
   // don't generate mask for blocks with small depth range (encoder decision)
   if( uiMaxDepth - uiMinDepth < 10 )
@@ -750,13 +870,13 @@
     return false;
   }
-  
+
   AOF(uiWidth==uiHeight);
   Int iMean = iSumDepth >> 2;
-  
+
   // start again for segmentation
   pDepthPels = pDepthBlockStart;
-  
+
   Bool bInvertMask = pDepthPels[0]>iMean; // top-left segment needs to be mapped to partIdx 0
-  
+
   // generate mask
   UInt uiSumPix[2] = {0,0};
@@ -765,26 +885,42 @@
     for (Int x=0; x<uiHeight; x++)
     {
+#if HS_DBBP_CLEAN_K0048
+      Int depthPel = 0;
+      if (iBlkX+x>iPictureWidth)
+      {
+        depthPel = pDepthPels[t];
+      }
+      else
+      {
+        depthPel = pDepthPels[x];
+        t=x;
+      }
+#else
       Int depthPel = pDepthPels[x];
-      
+#endif
+
       // decide which segment this pixel belongs to
       Int ucSegment = (Int)(depthPel>iMean);
-      
+
       if( bInvertMask )
       {
         ucSegment = 1-ucSegment;
       }
-      
+
       // count pixels for each segment
       uiSumPix[ucSegment]++;
-      
+
       // set mask value
       pMask[x] = (Bool)ucSegment;
     }
-    
+
     // next row
-    pDepthPels += uiDepthStride;
+#if HS_DBBP_CLEAN_K0048
+    if (!(iBlkY+y+1>iPictureHeight))
+#endif
+      pDepthPels += uiDepthStride;
     pMask += MAX_CU_SIZE;
   }
-  
+
   // don't generate valid mask for tiny segments (encoder decision)
   // each segment needs to cover at least 1/8th of block
@@ -794,5 +930,5 @@
     return false;
   }
-  
+
   // all good
   return true;
@@ -1157,5 +1293,7 @@
   TComMv      cMv         = pcCU->getCUMvField( eRefPicList )->getMv( uiPartAddr );
   pcCU->clipMv(cMv);
-
+#if SONY_MV_V_CONST_C0078
+  pcCU->checkMV_V(cMv, eRefPicList, iRefIdx );
+#endif
 #if H_3D_ARP
   if(pcCU->getARPW( uiPartAddr ) > 0  && pcCU->getSlice()->getRefPic( eRefPicList, iRefIdx )->getPOC()== pcCU->getSlice()->getPOC())
@@ -1255,4 +1393,8 @@
 #if H_3D_NBDV
   DisInfo cDistparity;
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+  cDistparity.m_acNBDV = pcCU->getDvInfo(0).m_acNBDV;
+  cDistparity.m_aVIdxCan = pcCU->getDvInfo(uiPartAddr).m_aVIdxCan;
+#else
   cDistparity.bDV           = pcCU->getDvInfo(uiPartAddr).bDV;
   if( cDistparity.bDV )
@@ -1262,11 +1404,17 @@
     cDistparity.m_aVIdxCan = pcCU->getDvInfo(uiPartAddr).m_aVIdxCan;
   }
+#endif
 #else
   assert(0); // ARP can be applied only when a DV is available
 #endif
-
+#if SEC_ARP_REM_ENC_RESTRICT_K0035
+  UChar dW = pcCU->getARPW ( uiPartAddr );
+#else
   UChar dW = cDistparity.bDV ? pcCU->getARPW ( uiPartAddr ) : 0;
-
+#endif
+
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
   if( cDistparity.bDV ) 
+#endif
   {
     Int arpRefIdx = pcCU->getSlice()->getFirstTRefIdx(eRefPicList);
@@ -1320,7 +1468,7 @@
       pYuvB0->clear(); pYuvB1->clear();
     }
-
+#if !SEC_ARP_REM_ENC_RESTRICT_K0035
     assert ( cDistparity.bDV );
-    
+#endif    
     TComMv cNBDV = cDistparity.m_acNBDV;
     pcCU->clipMv( cNBDV );
Index: /trunk/source/Lib/TLibCommon/TComPrediction.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComPrediction.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -175,6 +175,11 @@
   
 #if H_3D_DBBP
+#if HS_DBBP_CLEAN_K0048
+  PartSize      getPartitionSizeFromDepth(Pel* pDepthPels, UInt uiDepthStride, UInt uiSize, TComDataCU*& pcCU);
+  Bool          getSegmentMaskFromDepth( Pel* pDepthPels, UInt uiDepthStride, UInt uiWidth, UInt uiHeight, Bool* pMask, TComDataCU*& pcCU);
+#else
   PartSize      getPartitionSizeFromDepth(Pel* pDepthPels, UInt uiDepthStride, UInt uiSize);
   Bool          getSegmentMaskFromDepth( Pel* pDepthPels, UInt uiDepthStride, UInt uiWidth, UInt uiHeight, Bool* pMask );
+#endif
   Void          combineSegmentsWithMask( TComYuv* pInYuv[2], TComYuv* pOutYuv, Bool* pMask, UInt uiWidth, UInt uiHeight, UInt uiPartAddr, UInt partSize );
 #endif
Index: /trunk/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -341,5 +341,9 @@
     else if( eDFunc >= DF_HADS && eDFunc <= DF_HADS16N )
     {
+#if !RWTH_DBBP_NO_SATD_K0028
       rcDistParam.DistFunc = TComRdCost::xGetMaskedHADs;
+#else
+      rcDistParam.DistFunc = TComRdCost::xGetMaskedSAD;
+#endif
     }
     else if( eDFunc >= DF_VSD && eDFunc <= DF_VSD16N )
@@ -441,5 +445,9 @@
   if( m_bUseMask )
   {
+#if !RWTH_DBBP_NO_SATD_K0028
     rcDistParam.DistFunc = (bHADME)?TComRdCost::xGetMaskedHADs:TComRdCost::xGetMaskedSAD;
+#else
+    rcDistParam.DistFunc = TComRdCost::xGetMaskedSAD;
+#endif
   }
 #endif
@@ -464,5 +472,9 @@
   if( m_bUseMask )
   {
+#if !RWTH_DBBP_NO_SATD_K0028
     rcDP.DistFunc = (bHadamard)?TComRdCost::xGetMaskedHADs:TComRdCost::xGetMaskedSAD;
+#else
+    rcDP.DistFunc = TComRdCost::xGetMaskedSAD;
+#endif
   }
 #endif
@@ -717,4 +729,5 @@
 }
 
+#if !RWTH_DBBP_NO_SATD_K0028
 UInt TComRdCost::xGetMaskedHADs( DistParam* pcDtParam )
 {
@@ -834,4 +847,5 @@
   return uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8);
 }
+#endif
 
 UInt TComRdCost::xGetMaskedVSD( DistParam* pcDtParam )
Index: /trunk/source/Lib/TLibCommon/TComRdCost.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComRdCost.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -320,5 +320,7 @@
   static UInt xGetMaskedSSE     ( DistParam* pcDtParam );
   static UInt xGetMaskedSAD     ( DistParam* pcDtParam );
+#if !RWTH_DBBP_NO_SATD_K0028
   static UInt xGetMaskedHADs    ( DistParam* pcDtParam );
+#endif
   static UInt xGetMaskedVSD     ( DistParam* pcDtParam );
 #endif
Index: /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComRdCostWeightPrediction.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComRom.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComRom.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -391,12 +391,15 @@
 Bool g_tracePU = false; 
 Bool g_traceTU = false; 
+Bool g_disableNumbering = false; 
 Bool g_disableHLSTrace = false; 
-UInt64 g_stopAtCounter       = 0; 
+UInt64 g_stopAtCounter       = 937234; 
 Bool g_traceCopyBack         = false; 
 Bool g_decTraceDispDer       = false; 
 Bool g_decTraceMvFromMerge   = false; 
 Bool g_decTracePicOutput     = false; 
-Bool g_stopAtPos             = false; 
-Bool g_outputPos             = false; 
+Bool g_stopAtPos             = true; 
+Bool g_outputPos             = true;   
+Bool g_traceCameraParameters = false; 
+Bool g_encNumberOfWrittenBits     = true; 
 #endif
 #endif
@@ -600,10 +603,10 @@
 
   Bool stopFlag = false; 
-  if ( g_stopAtPos && poc == 0 && layerId == 1 )
+  if ( g_stopAtPos && poc == 0 && layerId == 2 )
   {
     Bool stopAtCU = true; 
     if ( stopAtCU )        // Stop at CU with specific size
     {    
-      stopFlag = ( cuPelX  == 888 ) && ( cuPelY  == 248 ) && ( cuWidth == 8 ) && ( cuHeight == 8); 
+      stopFlag = ( cuPelX  == 0 ) && ( cuPelY  == 0 ) && ( cuWidth == 8 ) && ( cuHeight == 8 ); 
     }
     else
@@ -633,5 +636,8 @@
       std::cout << "Break point here." << std::endl; 
     }
-    fprintf( g_hTrace, "%8lld  ", g_nSymbolCounter++ );
+    if ( !g_disableNumbering )
+    {  
+      fprintf( g_hTrace, "%8lld  ", g_nSymbolCounter++ );
+    }
     fprintf( g_hTrace, "%-50s       : %d\n", symbolName, val );     
     fflush ( g_hTrace );
@@ -739,6 +745,10 @@
   assert( uiWidth == uiHeight );
 
+#if SHARP_DMM_CLEAN_K0042
+  Int posStart = 0, posEnd = 0;
+#else
   UChar    uhStartX = 0,    uhStartY = 0,    uhEndX = 0,    uhEndY = 0;
   Int   iStepStartX = 0, iStepStartY = 0, iStepEndX = 0, iStepEndY = 0;
+#endif
 
   UInt uiBlockSize = 0;
@@ -752,4 +762,5 @@
   for( UInt uiOri = 0; uiOri < 6; uiOri++ )
   {
+#if !SHARP_DMM_CLEAN_K0042
     // init the edge line parameters for each of the 6 wedgelet types
     switch( uiOri )
@@ -762,13 +773,39 @@
     case( 5 ): {  uhStartX = (uiBlockSize-1); uhStartY = 0;               uhEndX = 0;               uhEndY = 0;               iStepStartX =  0; iStepStartY = +1; iStepEndX =  0; iStepEndY = +1; break; }
     }
-
+#endif
+
+#if SHARP_DMM_CLEAN_K0042
+    posEnd = (Int) racWedgeList.size();
+    if (uiOri == 0 || uiOri == 4)
+    {
+#endif
     for( Int iK = 0; iK < uiBlockSize; iK += (uiWidth>=16 ?2:1))
     {
       for( Int iL = 0; iL < uiBlockSize; iL += ((uiWidth>=16 && uiOri<4)?2:1) )
       {
+#if SHARP_DMM_CLEAN_K0042
+        Int xS = iK;
+        Int yS = 0;
+        Int xE = (uiOri == 0) ? 0 : iL;
+        Int yE = (uiOri == 0) ? iL : uiBlockSize - 1;
+        cTempWedgelet.setWedgelet( xS, yS, xE, yE, uiOri, eWedgeRes, ((iL%2)==0 && (iK%2)==0) );
+#else
         cTempWedgelet.setWedgelet( uhStartX + (iK*iStepStartX) , uhStartY + (iK*iStepStartY), uhEndX + (iL*iStepEndX), uhEndY + (iL*iStepEndY), (UChar)uiOri, eWedgeRes, ((iL%2)==0 && (iK%2)==0) );
+#endif
         addWedgeletToList( cTempWedgelet, racWedgeList, racWedgeRefList );
       }
     }
+#if SHARP_DMM_CLEAN_K0042
+    }
+    else
+    {
+      for (Int pos = posStart; pos < posEnd; pos++)
+      {
+        cTempWedgelet.generateWedgePatternByRotate(racWedgeList[pos], uiOri);
+        addWedgeletToList( cTempWedgelet, racWedgeList, racWedgeRefList );
+      }
+    }
+    posStart = posEnd;
+#endif
   }
 
Index: /trunk/source/Lib/TLibCommon/TComRom.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComRom.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComRom.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
-* Copyright (c) 2010-2014, ITU/ISO/IEC
+* Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
@@ -230,5 +230,5 @@
 
 #ifndef ENC_DEC_TRACE
-#define ENC_DEC_TRACE   0
+#define ENC_DEC_TRACE   0  
 #endif
 
@@ -257,4 +257,5 @@
  extern Bool   g_traceTU; 
  extern Bool   g_disableHLSTrace;       // USE g_HLSTraceEnable to toggle HLS trace. Not this one!
+ extern Bool   g_disableNumbering;      // Don't print numbers to trace file
  extern UInt64 g_stopAtCounter;         // Counter to set breakpoint. 
  extern Bool   g_traceCopyBack;         // Output samples on copy back  
@@ -264,4 +265,6 @@
  extern Bool   g_stopAtPos;             // Stop at position
  extern Bool   g_outputPos;             // Output position
+ extern Bool   g_traceCameraParameters; // Trace camera parameters
+ extern Bool   g_encNumberOfWrittenBits;// Trace number of written bits
 
 #define DTRACE_CU(x,y)             writeToTraceFile( x,y, g_traceCU );
Index: /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2014, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
Index: /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h
===================================================================
--- /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 1178)
+++ /trunk/source/Lib/TLibCommon/TComSampleAdaptiveOffset.h	(revision 1179)
@@ -4,5 +4,5 @@
  * granted under this license.  
  *
- * Copyright (c) 2010-2014, ITU/ISO/IEC
+ * Copyright (c) 2010-2015, ITU/ISO/IEC
  * All rights reserved.
  *
